<?php
namespace magic;


class Cart
{
    private $content = null;
    private $allCards = null;

    public function __construct()
    {
        if(isset($_SESSION['cart'])){
            $this->content = $_SESSION['cart'] ;
        }else{
            $this->content = array() ;
        }

        // chargement de toutes les cartes
        $data = file_get_contents($GLOBALS['PHP_DIR']."data/cards.json") ;
        $this->allCards = json_decode($data) ;

    }

    public function add(array $selection): void{
        foreach ($selection as $id){
            if (!isset($this->allCards->$id)) break ;
            if(isset($this->content[$id])){
                $this->content[$id] += 1 ;
            }else{
                $this->content[$id] = 1 ;
            }

        }
        $_SESSION['cart'] = $this->content ;
    }

    public function render():void{ ?>
        <form class="browser" method="post" autocomplete="off">
            <header style="flex-direction: column ; justify-content: center">
                <h1 style="padding: 5px">CART : <span id="num-cards"></span>$</h1>
            </header>
            <div class="browser-content-wrapper">
                <div class="browser-content">
                <?php
                foreach ($this->content as $id => $num):
                    $c = $this->allCards->$id ;
                    ?>
                    <div class="magic-card selected">
                        <img src="<?php echo $c->image_uris->normal ?>">
                        <legend>
                            <label for="<?php echo $c->id ?>"><?php echo $c->name ?></label>
                            <input type="number" disabled
                                   id="<?php echo $id ?>"
                                   name="<?php echo $id ?>"
                                   value="<?php echo $num ?>"
                            >
                        </legend>
                    </div>
                <?php endforeach; ?>
                </div>
            </div>
        </form>
        <script>
            let inputs = undefined
            let numCards = undefined
            document.addEventListener('DOMContentLoaded', function (){
                numCards = document.getElementById('num-cards')
                inputs = document.getElementsByTagName('input')
                countItems()
            })

            function countItems(){
                const price = 25
                let count = 0
                for(input of inputs){
                    let val = parseInt(input.value)
                    val = val >= 0 ? val : 0
                    count += val
                }
                numCards.innerHTML = count*price/100
            }

        </script>
        <?php
    }

}