<?php
namespace magic;


class Shop
{
    private object $cards ;

    public function __construct()
    {
        $data = file_get_contents($GLOBALS['PHP_DIR']."data/cards.json") ;
        $this->cards = json_decode($data) ;
    }

    public function generateShop(){ ?>
        <form class="browser" action="<?php echo$GLOBALS['DOCUMENT_DIR'] ?>pages/add_to_cart.php" method="post" autocomplete="off">
            <header>
                <div style="padding: 5px">SELECTION : <span id="num-cards"></span></div>
                <button type="submit" class="btn btn-dark" id="add-to-cart">Add to Cart</button>
            </header>
            <div class="browser-content-wrapper">
                <div class="browser-content">
                    <?php foreach($this->cards as $c) :?>
                    <div class="magic-card">
                        <img src="<?php echo $c->image_uris->normal ?>">
                        <legend>
                            <label for="<?php echo $c->id ?>"><?php echo $c->name ?></label>
                            <input class="form-check-input" type="checkbox" name="selection[]"
                                   value="<?php echo $c->id ?>"
                                   id="<?php echo $c->id ?>"
                            >
                        </legend>
                    </div>
                    <?php endforeach; ?>
                </div>
            </div>
        </form>
        <script>
            let number = undefined
            let count = 0
            let addToCartBtn = undefined
            document.addEventListener('DOMContentLoaded', function (){
                number = document.getElementById('num-cards');
                addToCartBtn = document.getElementById('add-to-cart')
                addToCartBtn.disabled = true
                let checks = document.querySelectorAll("input[type='checkbox']")
                for (c of checks){
                    c.addEventListener('change', function (e){
                        if (this.checked){
                            this.parentElement.parentElement.classList.add('selected')
                        }else{
                            this.parentElement.parentElement.classList.remove('selected')
                        }
                        count_selection()
                    })
                    c.parentElement.parentElement.addEventListener('click', function (){
                        let input = this.querySelector("input[type='checkbox']") ;
                        console.log(input)
                        input.checked = !input.checked ;
                        if (input.checked){
                            this.classList.add('selected')
                        }else{
                            this.classList.remove('selected')
                        }
                        count_selection()
                    })
                }
                count_selection()
            })

            function count_selection(){
                let selected = document.querySelectorAll("input[type='checkbox']:checked")

                if(selected.length == 0){
                    addToCartBtn.disabled = true
                    number.innerHTML = 'none'
                }else{
                    addToCartBtn.disabled = false
                    number.innerHTML = selected.length
                    selected.forEach(input =>{
                        console.log(input.parentElement.parentElement)
                    })
                }
            }
        </script>
    <?php
    }

}